class CustomException extends Exception{
	
}

class SuperClassWithDifferentMethods{
	  
	  protected int field1 = 10;
	  protected static int field2 = 20;   
	
	  public void method1() {
		  System.out.println("SuperClassWithDifferentMethods.method1()");
	  }
	  
	  public final void method2(){
		  System.out.println("SuperClassWithDifferentMethods.method2()");
	  }
	
	  private void method3() {
		  System.out.println("SuperClassWithDifferentMethods.method3()");
	  }
	  
	  private final void method4(){
		  System.out.println("SuperClassWithDifferentMethods.method4()");
	  }
	  
	  public static void method5() {
	        System.out.println("SuperClassWithDifferentMethods.method5()");
	  }
	  
	  public void method6() throws Exception {
		  System.out.println("SuperClassWithDifferentMethods.method6()");
	  }
	  
	  private void method7(){
		  System.out.println("SuperClassWithDifferentMethods.method7()");
	  }
	  
	  private void method8(int x){
		  System.out.println("SuperClassWithDifferentMethods.method8()");
	  }
	  
	  public static void method9() {
	        System.out.println("SuperClassWithDifferentMethods.method9()");
	  }
}

class OverridingClass extends SuperClassWithDifferentMethods {
	
	  public int field1 = 30;
	  public static int field2 = 40; 
	
	  public void method1() {
		  System.out.println("OverridingClass.method1()");
	  }
		  
	  //We can't override a public final method
/*	  public final void method2(){		
		  System.out.println("OverridingClass.method2()");
	  }*/

	  private void method3(){
		  System.out.println("OverridingClass.method3()");
	  }
	  
	  private final void method4(){
		  System.out.println("OverridingClass.method4()");
	  }
	  
	  public static void method5() {
	        System.out.println("OverridingClass.method5()");
	  }
	  
	  public void method6() throws CustomException{
		  System.out.println("OverridingClass.method6()");
	  }
	  
	  public void method7(){
			  System.out.println("OverridingClass.method7()");
	  }
	  
	  public void method8(final int x){
		  System.out.println("OverridingClass.method8()");
	  }
	  
	  //A static method cannot be overridden to be non-static instance method 
	  /*public void method9() {
	        System.out.println("OverridingClass.method9()");
	  }*/
	  
}

public class MethodOverridingDemo {
  
	public static void main(String[] args) {
	    OverridingClass oc1 = new OverridingClass();
	    SuperClassWithDifferentMethods sc3 = new OverridingClass();
	    oc1.method1();
	    oc1.method2();
	    
	    
//	    Since its private, the below 2 methods are not visible
/*	    oc1.method3();
	    oc1.method4();*/
	    
	    oc1.method5();
	    try {
			oc1.method6();
		} catch (CustomException e) {
			e.printStackTrace();
		}
	    oc1.method7();
	    oc1.method8(100);
	    System.out.println("oc1.field1 : "+oc1.field1);
	    System.out.println("oc1.field2 : "+oc1.field2);
	    System.out.println("sc3.field1 : "+sc3.field1);
	    System.out.println("sc3.field2 : "+sc3.field2);
	    sc3.method5();
	   
	    OverridingClass overClass = new OverridingClass();
        SuperClassWithDifferentMethods supClass = (SuperClassWithDifferentMethods)overClass;
        supClass.method5();                   
        supClass.method1();


	}
}